/* rpi.c - Provides routines specific to memu-pi */

#include "config.h"
#include "common.h"

#include <unistd.h>
/* #include <linux/reboot.h> */
#include <sys/reboot.h>
#include <stdio.h>

int memu_entry (int argc, char *argv[]);

void died (void)
	{
	printf ("Prgram died.\n");
	sleep (10);
	}

/* A replacement for the normal exit () system call, which halts the system */

void rpi_exit (int iStatus)
   {
   int iExit;
   /* Sync the file system to ensure all pending writes have completed */

   printf ("Memu-Pi exit called.\n");
   sync ();
   sleep (2);
   sync ();
   sleep (2);
   printf ("Filesystem sinced.\n");

   /* Give time to read error message */

   if ( iStatus != 0 )  sleep (10);

   /* Halt the system */

   printf ("Shutting down\n");
/*   iExit = reboot (LINUX_REBOOT_MAGIC1, LINUX_REBOOT_MAGIC2, LINUX_REBOOT_CMD_POWER_OFF, NULL); */
   iExit = reboot (RB_POWER_OFF);
   perror ("reboot: ");

   /* Failed to power down - wait forever */

   while (TRUE) sleep (1000000);
   }

int main (int argc, char *argv[])
	{
	printf ("memu-pi started.\n");
	atexit (died);
	printf ("argv[0] = %s\n", argv[0]);
	char *psCfg = cfg_find_file (argv[0]);
    printf ("psCfg = %s\n", psCfg);
	if ( psCfg == NULL )
		{
		psCfg = estrdup ("/memu/memu-pi.cfg");
		if ( ! cfg_test_file (psCfg) ) fatal ("No configuration file found");
		}
	if ( ! read_config (psCfg, &argc, &argv) ) fatal ("Error reading configuration file");
	free (psCfg);
	sleep (20);
	memu_entry (argc, argv);
	}

void exit (int iStatus)
	{
		printf ("exit (%d) function called.\n", iStatus);
	sleep (10);
	rpi_exit (iStatus);
	}
